package sdl.stupidModel;

import java.util.List;

import org.eclipse.core.runtime.IAdapterFactory;
import org.eclipse.amp.agf.IGraphicsAdapted;
import org.eclipse.amp.agf.IGraphicsAdapter;

import org.eclipse.swt.graphics.Color;
import org.eclipse.jface.viewers.IColorProvider;

import org.ascape.model.Agent;
import org.ascape.model.Cell;
import org.ascape.model.CellOccupant;
import org.ascape.model.HostCell;
import org.ascape.model.LocatedAgent;
import org.ascape.model.Scape;
import org.ascape.model.event.ScapeEvent;
import org.ascape.model.rule.Rule;
import org.ascape.model.rule.ExecuteThenUpdate;
import org.ascape.model.space.CollectionSpace;
import org.ascape.model.space.Coordinate;
import org.ascape.model.space.Coordinate2DDiscrete;
import org.ascape.model.space.Graph;
import org.ascape.model.space.Location;
import org.ascape.runtime.NonGraphicRunner;
import org.ascape.util.Conditional;
import org.ascape.util.data.DataPoint;
import org.ascape.util.data.DataPointConcrete;
import org.ascape.util.vis.ColorFeature;
import org.ascape.util.vis.ColorFeatureConcrete;
import org.ascape.view.vis.ChartView;
import org.ascape.view.vis.GEFView;
import org.ascape.view.vis.GraphView;

/**
 * stupidModel Java Implementation.
 * 
 * Generated by AMF for model: stupidModel.metaabm in project: sdl.stupidModel 
 */
public class StupidModel extends Scape implements IGraphicsAdapted {

	/**
	 * The number of bugs to create.
	 */
	private int bugCount = 100;

	/**
	 * 
	 */
	private double bugVision = 4;

	/**
	 * The horizontal extent of the space.
	 */
	private int grid2DWidth = 100;

	/**
	 * The vertical extent of the space.
	 */
	private int grid2DHeight = 100;

	/**
	 * 
	 */
	private Scape grid2D = null;

	/**
	 * Constructs a new stupidModel.
	 */
	public StupidModel() {
	}

	//todo, make this a useful value for evaluating compatibility of different versions of generated classes
	private static final long serialVersionUID = 89989998L;

	private static long nextUniqueID;

	private long uniqueID;

	public long getUID() {
		if (uniqueID == 0) {
			uniqueID = nextUniqueID++;
		}
		return uniqueID;
	}

	/**
	 * Clones the agent, ensuring that a unique id is assigned.
	 */
	public Object clone() {
		try {
			StupidModel clone = (StupidModel) super.clone();
			clone.uniqueID = 0;
			return clone;
		} catch (Exception e) {
			throw new RuntimeException("Unexpected cloning exception: " + e);
		}
	}

	org.ascape.model.Scape bugScape;

	/**
	 * Create an instance of Bug that will be used to populate the bugScape.
	 * Overide to customize the prototype, for example to change the views created for a member scape.
	 */
	protected Bug createBugPrototype() {
		return new Bug();
	}

	static int next_vm_id;

	int vm_unique_id;

	/**
	 * Creates the members of stupidModel. 
	 */
	public void createScape() {
		super.createScape();

		setName("stupidModel");
		Bug bugProto = createBugPrototype();
		bugScape = new Scape();
		bugScape.setName("Bugs");
		bugScape.setPrototypeAgent(bugProto);
		bugScape.setExecutionOrder(Scape.RULE_ORDER);
		bugScape.setSize(bugCount);
		grid2D = new Scape(new org.ascape.model.space.Array2DMoore());
		grid2D.setExecutionOrder(Scape.RULE_ORDER);
		grid2D.setPrototypeAgent(new HostCell());
		grid2D.setExtent(new org.ascape.model.space.Coordinate2DDiscrete(
				getGrid2DWidth(), getGrid2DHeight()));

		grid2D.setName("Grid 2Ds");
		((CollectionSpace) grid2D.getSpace()).setPeriodic(true);
		add(grid2D);

		add(bugScape);
		bugProto.setHostScape(grid2D);
		grid2D.getRules().clear();

		bugScape.addStatCollector(new org.ascape.util.data.StatCollectorCond(
				getName() + " Population") {
			private static final long serialVersionUID = 684614444640209893L;

			@SuppressWarnings("unused")
			public final boolean meetsCondition(Object object) {
				return true;
			}
		});

		bugScape.addInitialRule(new Rule("Initialize") {
			private static final long serialVersionUID = 6846144446402098982L;
			public void execute(Agent a) {
				((sdl.stupidModel.Bug) a).intializeNonFramework();
			}
		});
		bugScape.addRule(new Rule("Bug Rule") {
			private static final long serialVersionUID = 6846144446402098981L;
			public void execute(Agent a) {
				((sdl.stupidModel.Bug) a).bugRule();
			}
		});

	}

	/**
	 * Creates UI views for stupidModel.
	 */
	public void createGraphicViews() {
		super.createGraphicViews();
		ChartView chart = new ChartView();

		final StupidModel bugScape = new StupidModel();
		bugScape.setRunner(new NonGraphicRunner());
		Bug bug = new Bug() {
			public void requestUpdate() {
			}
			public StupidModel getStupidModel() {
				return bugScape;
			}
		};
		bugScape.add(bug);
		HostCell bugHost = new HostCell() {
			public void requestUpdate() {
			}
		};
		bugHost.setOccupant((CellOccupant) bug);

		IColorProvider bugStyle2DColorProvider = new BugStyle2DColorProvider();
		addView(chart);
		addView(new GEFView());
	}

	public void scapeSetup(ScapeEvent scapeEvent) {
		//Set the size of the scape populations, e.g. for mutable scapes that need to have their size reset

		bugScape.setSize(bugCount);
	}

	/**
	 * Returns the Scape containing Bugs.
	 */
	public org.ascape.model.Scape getBugScape() {
		return bugScape;
	}

	public IGraphicsAdapter getGraphicsAdapter() {
		return StupidModelGraphicsAdapter.getDefault();
	}

	private Color getInferredChartColor(Object agent,
			IColorProvider colorProvider) {
		Color color = colorProvider.getForeground(agent);
		if (color == ColorFeature.BLACK) {
			color = ColorFeatureConcrete.createHSB(
					(float) java.lang.Math.random() * 360f, 1.0f, 0.8f);
		}
		return color;
	}

	public static void main(String[] args) {
		(new NonGraphicRunner()).openInstance("sdl.stupidModel.StupidModel");
	}
	/**
	 * Gets the Bug Count property for stupidModel.
	 * @return The number of bugs to create.
	 */
	public int getBugCount() {
		return bugCount;
	}

	/**
	 * Sets the Bug Count property for stupidModel.
	 * The number of bugs to create.
	 * @param _bugCount the new Bug Count value
	 */
	public void setBugCount(int _bugCount) {
		bugCount = _bugCount;
	}

	/**
	 * Gets the Bug Vision property for stupidModel.
	 * @return 
	 */
	public double getBugVision() {
		return bugVision;
	}

	/**
	 * Sets the Bug Vision property for stupidModel.
	 * 
	 * @param _bugVision the new Bug Vision value
	 */
	public void setBugVision(double _bugVision) {
		bugVision = _bugVision;
	}

	/**
	 * Gets the Width property for Grid 2D.
	 * @return The horizontal extent of the space.
	 */
	public int getGrid2DWidth() {
		return grid2DWidth;
	}

	/**
	 * Sets the Width property for Grid 2D.
	 * The horizontal extent of the space.
	 * @param _grid2DWidth the new Width value
	 */
	public void setGrid2DWidth(int _grid2DWidth) {
		grid2DWidth = _grid2DWidth;
	}

	/**
	 * Gets the Height property for Grid 2D.
	 * @return The vertical extent of the space.
	 */
	public int getGrid2DHeight() {
		return grid2DHeight;
	}

	/**
	 * Sets the Height property for Grid 2D.
	 * The vertical extent of the space.
	 * @param _grid2DHeight the new Height value
	 */
	public void setGrid2DHeight(int _grid2DHeight) {
		grid2DHeight = _grid2DHeight;
	}

	/**
	 * Gets the Grid 2D property for stupidModel.
	 * @return 
	 */
	public Scape getGrid2D() {
		return grid2D;
	}

	/**
	 * Sets the Grid 2D property for stupidModel.
	 * 
	 * @param _grid2D the new Grid 2D value
	 */
	public void setGrid2D(Scape _grid2D) {
		grid2D = _grid2D;
	}

	public String getName() {
		if (name == null) {
			return "stupidModel " + getUID();
		} else {
			return name;
		}
	}
}
